searchNodes=[{"doc":"Ecto-backed Authorization Library for Elixir Applications See README for a description of the mathematical model used as the basis of this system. Usage Imagine you are creating an app that handles online ordering. First, create your app's authorization module, configuring it with your application repository: defmodule Auth do use Authorizir , repo : Repo end Users of the application might be organized into a hierarchy as follows (note that an employee can also be a customer): graph TD *[Users *] --&gt; E[Employees] * --&gt; C[Customers] E --&gt; A[Admins] E --&gt; M[Marketing] E --&gt; F[Finance] E --&gt; S[Shipping and Fulfillment] A --&gt; Bob M --&gt; Bob M --&gt; Jane F --&gt; Amanda S --&gt; George S --&gt; Beth C --&gt; Amanda C --&gt; George C --&gt; John We have two types of Subject entities represented here; &quot;Organizational Units&quot; represent groups of users such as internal departments and customers, while &quot;Users&quot; represent the individual system accounts. Each of these are represented with Ecto schemas in our app, and we include the Authorizir.Subject behavior in the modules, so that they can participate in the Subject hierarcy. First we add the necessary migrations by running mix ecto.gen.migraion add_org_units_and_users and editing the resulting migration file: defmodule AddOrgUnitsAndUsers do use Ecto.Migration import Authorizir.Migrations , only : [ apply_subject_hierarchy : 2 ] create table ( &quot;org_units&quot; ) do add :name , :string , null : false timestamps ( ) end apply_subject_hierarchy ( &quot;org_units&quot; , id_field : :id ) create table ( &quot;users&quot; ) do add :name , :string , null : false timestamps ( ) end apply_subject_hierarchy ( &quot;users&quot; , id_field : :id ) end defmodule OrgUnit do use Ecto.Schema use Authorizir.Subject schema &quot;org_units&quot; do field :name , :string end end defmodule User do use Ecto.Schema use Authorizir.Subject schema &quot;users&quot; do field :name , :string end end You can create the hierarchy as: { :ok , employees } = % OrgUnit { name : &quot;Employees&quot; } |&gt; Repo . insert ( ) { :ok , customers } = % OrgUnit { name : &quot;Customers&quot; } |&gt; Repo . insert ( ) { :ok , admins } = % OrgUnit { name : &quot;Admins&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( employees . id , admins . id , Subject ) { :ok , marketing } = % OrgUnit { name : &quot;Marketing&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( employees . id , marketing . id , Subject ) { :ok , finance } = % OrgUnit { name : &quot;Finance&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( employees . id , finance . id , Subject ) { :ok , shipping } = % OrgUnit { name : &quot;Shipping and Fulfillment&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( employees . id , shipping . id , Subject ) { :ok , bob } = % User { name : &quot;Bob&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( admins . id , bob . id , Subject ) :ok = Auth . add_child ( marketing . id , bob . id , Subject ) { :ok , jane } = % User { name : &quot;Jane&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( marketing . id , jane . id , Subject ) { :ok , amanda } = % User { name : &quot;Amanda&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( finance . id , amanda . id , Subject ) :ok = Auth . add_child ( customers . id , amanda . id , Subject ) { :ok , george } = % User { name : &quot;George&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( shipping . id , george . id , Subject ) :ok = Auth . add_child ( customers . id , george . id , Subject ) { :ok , beth } = % User { name : &quot;Beth&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( shipping . id , beth . id , Subject ) { :ok , john } = % User { name : &quot;John&quot; } |&gt; Repo . insert ( ) :ok = Auth . add_child ( customers . id , john . id , Subject )","ref":"Authorizir.html","title":"Authorizir","type":"behaviour"},{"doc":"","ref":"Authorizir.html#c:add_child/3","title":"Authorizir.add_child/3","type":"callback"},{"doc":"","ref":"Authorizir.html#add_child/4","title":"Authorizir.add_child/4","type":"function"},{"doc":"","ref":"Authorizir.html#c:allow_permission/3","title":"Authorizir.allow_permission/3","type":"callback"},{"doc":"","ref":"Authorizir.html#allow_permission/4","title":"Authorizir.allow_permission/4","type":"function"},{"doc":"","ref":"Authorizir.html#c:deny_permission/3","title":"Authorizir.deny_permission/3","type":"callback"},{"doc":"","ref":"Authorizir.html#deny_permission/4","title":"Authorizir.deny_permission/4","type":"function"},{"doc":"","ref":"Authorizir.html#c:grant_permission/3","title":"Authorizir.grant_permission/3","type":"callback"},{"doc":"","ref":"Authorizir.html#grant_permission/4","title":"Authorizir.grant_permission/4","type":"function"},{"doc":"","ref":"Authorizir.html#c:init/0","title":"Authorizir.init/0","type":"callback"},{"doc":"","ref":"Authorizir.html#permission/3","title":"Authorizir.permission/3","type":"macro"},{"doc":"","ref":"Authorizir.html#c:permission_declarations/0","title":"Authorizir.permission_declarations/0","type":"callback"},{"doc":"","ref":"Authorizir.html#c:permission_granted?/3","title":"Authorizir.permission_granted?/3","type":"callback"},{"doc":"","ref":"Authorizir.html#permission_granted?/4","title":"Authorizir.permission_granted?/4","type":"function"},{"doc":"","ref":"Authorizir.html#c:register_object/3","title":"Authorizir.register_object/3","type":"callback"},{"doc":"","ref":"Authorizir.html#register_object/4","title":"Authorizir.register_object/4","type":"function"},{"doc":"","ref":"Authorizir.html#c:register_permission/3","title":"Authorizir.register_permission/3","type":"callback"},{"doc":"","ref":"Authorizir.html#register_permission/4","title":"Authorizir.register_permission/4","type":"function"},{"doc":"","ref":"Authorizir.html#c:register_subject/3","title":"Authorizir.register_subject/3","type":"callback"},{"doc":"","ref":"Authorizir.html#register_subject/4","title":"Authorizir.register_subject/4","type":"function"},{"doc":"","ref":"Authorizir.html#c:remove_child/3","title":"Authorizir.remove_child/3","type":"callback"},{"doc":"","ref":"Authorizir.html#remove_child/4","title":"Authorizir.remove_child/4","type":"function"},{"doc":"","ref":"Authorizir.html#c:revoke_permission/3","title":"Authorizir.revoke_permission/3","type":"callback"},{"doc":"","ref":"Authorizir.html#revoke_permission/4","title":"Authorizir.revoke_permission/4","type":"function"},{"doc":"","ref":"Authorizir.html#role/3","title":"Authorizir.role/3","type":"macro"},{"doc":"","ref":"Authorizir.html#c:role_declarations/0","title":"Authorizir.role_declarations/0","type":"callback"},{"doc":"Migrations create and modify the database tables Authorizir needs to function. Usage To use migrations in your application you'll need to generate an Ecto.Migration that wraps calls to Authorizir.Migrations : mix ecto.gen.migration add_authorizir Open the generated migration in your editor and call the up and down functions on Authorizir.Migrations : defmodule MyApp.Repo.Migrations.AddAuthorizir do use Ecto.Migration def up , do : Authorizir.Migrations . up ( ) def down , do : Authorizir.Migrations . down ( ) end This will run all of Authorizir's versioned migrations for your database. Migrations between versions are idempotent. As new versions are released you may need to run additional migrations. Now, run the migration to create the table: mix ecto.migrate","ref":"Authorizir.Migrations.html","title":"Authorizir.Migrations","type":"module"},{"doc":"Run the down changes for all migrations between the current version and the initial version. Example Run all migrations from current version down to the first: Authorizir.Migrations . down ( ) Run migrations down to a specified version: Authorizir.Migrations . down ( version : 5 )","ref":"Authorizir.Migrations.html#down/1","title":"Authorizir.Migrations.down/1","type":"function"},{"doc":"Run the up changes for all migrations between the initial version and the current version. Example Run all migrations up to the current version: Authorizir.Migrations . up ( ) Run migrations up to a specified version: Authorizir.Migrations . up ( version : 2 )","ref":"Authorizir.Migrations.html#up/1","title":"Authorizir.Migrations.up/1","type":"function"},{"doc":"Authorizir is an Ecto-backed authorization library for Elixir applications that allows for a flexible, cascading, privilege grant/denial based system that can be applied to hierarchies of both subjects (the entity to which a privilege is granted or denied) and objects (the entity that a subject is attempting to access/modify). Authorizir requires the use of PostgreSQL with the ltree extension . The ltree extension is used internally to maintain the directed, acyclic graphs representing the Subject, Object, and Privilege hierarchies that are explained in the remainder of this document. 1","ref":"readme.html","title":"Authorizir","type":"extras"},{"doc":"The following terms are used throughout this document to describe aspects of authorization and access control: Subject : An entity that is attempting to perform an operation, e.g. a logged-in user or an API client Object : An entity that is the target of an operation being performed by a Subject, e.g. if a logged-in user (Subject) attempts to update a record, the Object is the record. Privilege : Represents a discrete business operation with semantic meaning to the application that is responsible for performing that operation, e.g. if a logged-in user (Subject) attempts to update an assignment (Object), the Privilege might simply be update_assignments or it may be more granular such as schedule_assignment. Grant : Used in combination with a Privilege to signify that the Privilege is either explicitly granted (Positive Grant) or explicitly denied (Negative Grant). Access Rule : Defines a combination of Subject, Object, Privilege, and Grant. Application : In this document, unless otherwise specified, an Application is any deployed application or service within your platform that will use the Authorization System to control access to its data and operations. Authorization Query : A combination of specific Subject, Object, and Privilege identities used as input to the Authorization System when an Application requests an Authorization. Authorization : For a given Authorization Query, the Authorization is the final determination of the Grant value (Positive Grant or Negative Grant) after considering all defined Access Rules that directly or indirectly apply to the entities specified in the Authorization Query.","ref":"readme.html#definitions","title":"Authorizir - Definitions","type":"extras"},{"doc":"The Authorization System described in this document is based on the system described by Andreas Geyer-Schulz and Anke Thede in Implementation of Hierarchical Authorization for a Web Based Digital Library 2 uses three distinct hierarchies to model Access Rules: Subjects , Objects , and Privileges . This is similar to the NIST level-2 RBAC model 3 in that Privilege assignments can be propagated along a hierarchy of Subjects in a manner that is similar to the use of Role hierarchies, however RBAC does not inherently address the need for a similar hierarchy in the set of Objects. In this Authorization System, we maintain the primary advantages of the RBAC model while largely avoiding the inherent downsides of shared Roles; we do not explicitly model the use of ABAC, however the model can be extended in various ways to support ABAC as an Application-level concern. Guiding Principles Authorizir adheres to the following guiding principles in order to provide an authorization system that is both secure and adaptable to a wide variety of needs: A Subject can be any type of uniquely-identifiable entity, whether authenticated (e.g. an internal Administrator, a User account, or an API client) or anonymous (e.g. someone accessing data from an emailed link that does not require them to log in). (N.B. The authorization system is not responsible for authenticating the Subject; Applications must take other measures to ensure that Privileges are being checked against the appropriate Subject identity.) Authorizir has no semantic knowledge about the Subjects aside from modeling their hierarchy as a directed, acyclic graph of IDs. An Object can also be any type of uniquely-identifiable entity. Authorizir has no semantic knowledge about the Objects aside from modeling their hierarchy as a directed, acyclic graph of IDs. A single entity MAY be represented as both a Subject and an Object (e.g. the User entity, &quot;Jim&quot;, may be assigned Privileges for their use of a system—thus behaving as a Subject—and a different User, &quot;Ann&quot;, may have privileges that allow them to act on the &quot;Jim&quot; entity—in which case &quot;Jim&quot; is behaving as an Object.) A Privilege represents a discrete business operation that a Subject may be able to perform on an Object. Authorizir does not require semantic knowledge of Privileges (aside from any Privileges that apply to the authorization system itself). Each Application is responsible for implementing the semantics of the Privileges that affect its operations. Using only the identities (e.g. the ID attributes) of a Subject, Object, and a Privilege, an Application is able to submit an Authorization Query and receive an Authorization. Any Privilege that is not explicitly granted is denied. If multiple Access Rules are defined that directly or indirectly affect a given combination of Subject, Object, and Privilege, the most restrictive Access Rule will apply. In other words, if Access Rule $r$ implies that Subject $s$ has a Positive Grant for Privilege $p$ on Object $o$, and Access Rule $r'$ implies that Subject $s$ has a Negative Grant for Privilege $p$ on Object $o$, when the Authorization System applies both rules, the resulting Authorization must be a Negative Grant. TODO 4 : No Subject $s$ shall be capable of creating an Access Rule that will change the resulting Privilege of that same Subject $s$ (i.e. a Subject cannot create a rule that would result in a Positive Grant on an Object for which the Subject does not already have a Positive Grant.) TODO 4 : No Subject $s$ shall be capable of creating an Access Rule affecting a Privilege $p$ on an Object $o$ to another Subject $s'$ where $s$ does not already have a Positive Grant Authorization for $p$ on $o$ (i.e. if you do not have a given privilege, then you also may not grant someone else that privilege.) Access Rules The canonical access control model is defined as the relation $R_S \\sube S \\times P \\times O$ where $S$ is the set of all Subjects, $P$ is the set of all Privileges, $O$ is the set of all Objects, and $G = \\lbrace +,- \\rbrace $ (either a Positive Grant or a Negative Grant). Access Rules are defined in terms of two tuples such that a Positive Grant is $\\langle s,p,o,+ \\rangle$ and a Negative Grant is $\\langle s,p,o,- \\rangle$. The Negative Grant is defined explicitly rather than relying only on the lack of a Positive Grant, because an explicit Negative Grant can be used to override a Positive Grant in situations where a Subject is related to an Object through multiple paths. The Subject and Object Hierarchies Each of the sets of Subjects and Objects are defined as a hierarchy created using a partial order on its elements. This allows Access Rules to be defined such that they can be applied not just to individual elements but also to any subsets of Subjects and Objects. Each hierarchy can be generalized such that for set $X \\in \\lbrace S,O \\rbrace$, the partial order is defined on the power set $P(X)$. The hierarchical relationship between elements of each of these sets is expressed as $$Y = P(X) \\newline \\forall \\lbrace X_i \\mid X_i \\in Y \\rbrace , X_i \\in X_j \\iff (X_j \\in Y \\land X_i \\prec_Y X_j)$$ Each element in $P(X)$ is given a name reflecting the semantics of those elements within the business domain (i.e. a given Subject may have the name &quot;John Doe&quot; and an Object may have the name &quot;Blog Posts&quot;.) The set of names for all elements in $P(X)$ is denoted as $X_N$ and $* \\in X_N$ is the supremum of set $X$. The relation between elements of set $X$ and their names is defined as the bijection $\\upsilon_X:X_N \\to X$. We also define the functions $su:X \\to P(X)$ and $pr:X \\to P(X)$ such that $su(x) \\to \\lbrace y:y \\prec_X x \\rbrace$ (the set of all subsets of $x \\in X$) and $pr(x) \\to \\lbrace y:y \\succ_X x \\rbrace$ (the set of all supersets of $x \\in X$.) These functions are used to find all of the possible descendants or ascendants, respectively, of a given entity in one of the three hierarchies, so that the Access Rules for that entity can be determined for any given $\\langle s,o,p \\rangle$, even where those Access Rules are only made explicit on other elements in any of the hierarchies. This simplifies the management of the Access Rules by reducing the number of distinct Access Rules that must be created. In particular it allows for the appropriate access controls to be applied to both Subjects and Objects as a natural consequence of their organization within the relevant Applications. The Privilege Hierarchy The privilege hierarchy is slightly different in that the partial order $\\prec P$ is defined directly on the set $P$ rather than on the power set of $P$ such that $$\\forall \\lbrace p_i | p_i \\in P \\rbrace, p_j \\in p_i \\iff (p_j \\in P \\land p_i \\prec_P p_j)$$ This means that Privilege $p_j$ implies $p_i$, or in other words, a Subject that has been granted $p_j$ has necessarily also been granted $p_i$. This makes sense for Privileges, as one Privilege (such as “edit document”, for example) may necessarily require another Privilege (“read document”). By creating a hierarchy allowing for this implication, we avoid unnecessarily explicit specification of Access Rules in such cases. Similar to the other two hierarchies, $P_N$ represents the set of names for all of the Privileges in $P$. Privilege Propagation and Conflict Resolution Privileges are granted or revoked by specifying an Access Rule as $r = \\langle s_n, o_n , p_n \\rangle \\in S_N \\times O_N \\times P_N \\times G$, which can then be translated into a set of canonical access definitions with the function $$T:S_N \\times O_N \\times P_N \\times G \\to P(S \\times O \\times P \\times G)$$ so that for an Access Rule $a = \\langle a_S, a_O, a_P, a_G \\rangle$: $$ T(a) = \\begin{cases} su_S(\\nu(a_S)) \\times su_O(\\nu(a_O)) \\times su_P(\\nu(a_P)) \\times + &amp; \\iff &amp; a_G = + \\newline su_S(\\nu(a_S)) \\times su_O(\\nu(a_O)) \\times pr_P(\\nu(a_P)) \\times - &amp; \\iff &amp; a_G = - \\end{cases} $$ Note that there is a difference in the direction of propagation applied to the Privilege depending on the value of $a_G$. This is the method by which we ensure that the explicit denial of a Privilege will always take precedence, even to the point of denying a superior privilege that was explicitly granted. For example, let's say that Subject &quot;John&quot; has been granted the &quot;edit&quot; privilege on the group of objects, &quot;Blog Posts&quot;. The &quot;edit&quot; privilege is an ancestor of the &quot;read&quot; privilege (i.e. having &quot;edit&quot; implies also having &quot;read&quot;.) Within the &quot;Blog Posts&quot; group, there is a sub-group called &quot;Private&quot;. There exist an access rule that declares a negative grant for &quot;John&quot; on the &quot;Private&quot; group for the &quot;read&quot; privilege. Even though the positive grant of the &quot;edit&quot; privilege on &quot;Blog Posts&quot; for &quot;John&quot; would normally apply to everything in that object group, including the &quot;Private&quot; group, the explicit denial of the &quot;read&quot; privilege on the &quot;Private&quot; group also transalates into a denial of the &quot;edit&quot; privilege on the &quot;Private&quot; group. In order to determine the Authorization for a given $\\langle s, o, p \\rangle$, we use the function $cA : S \\times O \\times P \\to \\lbrace true, false \\rbrace$ defined as: $$ cA(\\langle s, o, p \\rangle ) = \\exists \\lbrace \\langle s \\prime , o \\prime, p \\prime \\rangle \\in S_N \\times O_N \\times P_N : \\langle s, o, p, + \\rangle \\in T(\\langle s \\prime, o \\prime, p \\prime, + \\rangle ) \\rbrace \\newline \\hphantom{cA\\langle s, o, p \\rangle ) = } \\land \\nexists \\lbrace \\langle \\hat{s}, \\hat{o}, \\hat{p} \\rangle \\in S_N \\times O_N \\times P_N : \\langle s, o, p, - \\rangle \\in T(\\langle \\hat{s}, \\hat{o}, \\hat{p}, - \\rangle ) \\rbrace $$ If the given combination of subject, object, and privilege can be derived from a Positive Grant using the translation function $T$ and if there is no Negative Grant that also can be translated to the given subject, object, and privilege, then the result is true, or a Positive Grant Authorization; otherwise, if there is either no explicit Positive Grant, or if there is an explicit Negative Grant, then the result will be false, or a Negative Grant Authorization. Although the use of Negative Grants is available as needed, the fact that they cannot be overridden at lower levels of the Subject and Object hierarchies means that they should generally be used only as necessary and in the tightest scope possible (i.e. towards the leaf nodes of the hierarchies); in practice, almost all useful configurations of Access Rules for a system can be derived from the use of Positive Grants, since the default in the absence of any applicable Access Rule is $cA(a)=false$. &amp;#x21A9; X. B. Talavera, “DAGs with materialized paths using postgres ltree,” bustawin, Aug. 27, 2018. https://www.bustawin.com/dags-with-materialized-paths-using-postgres-ltree/ (accessed Jan. 06, 2022). &amp;#x21A9; A. Geyer-Schulz and A. Thede, “Implementation of Hierarchical Authorization For A Web Based Digital Library,” Systemics, Cybertetics and Informatics, 2007, doi: 10.54808/JSCI. &amp;#x21A9; R. Sandhu, D. Ferraiolo, and R. Kuhn, “The NIST model for role-based access control,” Proceedings of the fifth ACM workshop on Role-based access control  - RBAC ’00, 2000, doi: 10.1145/344287.344301. &amp;#x21A9; Authorizir does not currently enforce any authorization rules about changing the authorization rules themselves. I'm considering if and how-best to implement such a feature. For now, though, it is up to each dependant application to create and enforce rules regarding changes to its own authorization rules.","ref":"readme.html#a-hierarchical-model-for-access-control","title":"Authorizir - A Hierarchical Model for Access Control","type":"extras"},{"doc":"Apache License Version 2.0, January 2004 http://www.apache.org/licenses/ TERMS AND CONDITIONS FOR USE, REPRODUCTION, AND DISTRIBUTION 1. Definitions. &quot;License&quot; shall mean the terms and conditions for use, reproduction, and distribution as defined by Sections 1 through 9 of this document. &quot;Licensor&quot; shall mean the copyright owner or entity authorized by the copyright owner that is granting the License. &quot;Legal Entity&quot; shall mean the union of the acting entity and all other entities that control, are controlled by, or are under common control with that entity. For the purposes of this definition, &quot;control&quot; means (i) the power, direct or indirect, to cause the direction or management of such entity, whether by contract or otherwise, or (ii) ownership of fifty percent (50%) or more of the outstanding shares, or (iii) beneficial ownership of such entity. &quot;You&quot; (or &quot;Your&quot;) shall mean an individual or Legal Entity exercising permissions granted by this License. &quot;Source&quot; form shall mean the preferred form for making modifications, including but not limited to software source code, documentation source, and configuration files. &quot;Object&quot; form shall mean any form resulting from mechanical transformation or translation of a Source form, including but not limited to compiled object code, generated documentation, and conversions to other media types. &quot;Work&quot; shall mean the work of authorship, whether in Source or Object form, made available under the License, as indicated by a copyright notice that is included in or attached to the work (an example is provided in the Appendix below). &quot;Derivative Works&quot; shall mean any work, whether in Source or Object form, that is based on (or derived from) the Work and for which the editorial revisions, annotations, elaborations, or other modifications represent, as a whole, an original work of authorship. For the purposes of this License, Derivative Works shall not include works that remain separable from, or merely link (or bind by name) to the interfaces of, the Work and Derivative Works thereof. &quot;Contribution&quot; shall mean any work of authorship, including the original version of the Work and any modifications or additions to that Work or Derivative Works thereof, that is intentionally submitted to Licensor for inclusion in the Work by the copyright owner or by an individual or Legal Entity authorized to submit on behalf of the copyright owner. For the purposes of this definition, &quot;submitted&quot; means any form of electronic, verbal, or written communication sent to the Licensor or its representatives, including but not limited to communication on electronic mailing lists, source code control systems, and issue tracking systems that are managed by, or on behalf of, the Licensor for the purpose of discussing and improving the Work, but excluding communication that is conspicuously marked or otherwise designated in writing by the copyright owner as &quot;Not a Contribution.&quot; &quot;Contributor&quot; shall mean Licensor and any individual or Legal Entity on behalf of whom a Contribution has been received by Licensor and subsequently incorporated within the Work. 2. Grant of Copyright License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable copyright license to reproduce, prepare Derivative Works of, publicly display, publicly perform, sublicense, and distribute the Work and such Derivative Works in Source or Object form. 3. Grant of Patent License. Subject to the terms and conditions of this License, each Contributor hereby grants to You a perpetual, worldwide, non-exclusive, no-charge, royalty-free, irrevocable (except as stated in this section) patent license to make, have made, use, offer to sell, sell, import, and otherwise transfer the Work, where such license applies only to those patent claims licensable by such Contributor that are necessarily infringed by their Contribution(s) alone or by combination of their Contribution(s) with the Work to which such Contribution(s) was submitted. If You institute patent litigation against any entity (including a cross-claim or counterclaim in a lawsuit) alleging that the Work or a Contribution incorporated within the Work constitutes direct or contributory patent infringement, then any patent licenses granted to You under this License for that Work shall terminate as of the date such litigation is filed. 4. Redistribution. You may reproduce and distribute copies of the Work or Derivative Works thereof in any medium, with or without modifications, and in Source or Object form, provided that You meet the following conditions: (a) You must give any other recipients of the Work or Derivative Works a copy of this License; and (b) You must cause any modified files to carry prominent notices stating that You changed the files; and (c) You must retain, in the Source form of any Derivative Works that You distribute, all copyright, patent, trademark, and attribution notices from the Source form of the Work, excluding those notices that do not pertain to any part of the Derivative Works; and (d) If the Work includes a &quot;NOTICE&quot; text file as part of its distribution, then any Derivative Works that You distribute must include a readable copy of the attribution notices contained within such NOTICE file, excluding those notices that do not pertain to any part of the Derivative Works, in at least one of the following places: within a NOTICE text file distributed as part of the Derivative Works; within the Source form or documentation, if provided along with the Derivative Works; or, within a display generated by the Derivative Works, if and wherever such third-party notices normally appear. The contents of the NOTICE file are for informational purposes only and do not modify the License. You may add Your own attribution notices within Derivative Works that You distribute, alongside or as an addendum to the NOTICE text from the Work, provided that such additional attribution notices cannot be construed as modifying the License. You may add Your own copyright statement to Your modifications and may provide additional or different license terms and conditions for use, reproduction, or distribution of Your modifications, or for any such Derivative Works as a whole, provided Your use, reproduction, and distribution of the Work otherwise complies with the conditions stated in this License. 5. Submission of Contributions. Unless You explicitly state otherwise, any Contribution intentionally submitted for inclusion in the Work by You to the Licensor shall be under the terms and conditions of this License, without any additional terms or conditions. Notwithstanding the above, nothing herein shall supersede or modify the terms of any separate license agreement you may have executed with Licensor regarding such Contributions. 6. Trademarks. This License does not grant permission to use the trade names, trademarks, service marks, or product names of the Licensor, except as required for reasonable and customary use in describing the origin of the Work and reproducing the content of the NOTICE file. 7. Disclaimer of Warranty. Unless required by applicable law or agreed to in writing, Licensor provides the Work (and each Contributor provides its Contributions) on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied, including, without limitation, any warranties or conditions of TITLE, NON-INFRINGEMENT, MERCHANTABILITY, or FITNESS FOR A PARTICULAR PURPOSE. You are solely responsible for determining the appropriateness of using or redistributing the Work and assume any risks associated with Your exercise of permissions under this License. 8. Limitation of Liability. In no event and under no legal theory, whether in tort (including negligence), contract, or otherwise, unless required by applicable law (such as deliberate and grossly negligent acts) or agreed to in writing, shall any Contributor be liable to You for damages, including any direct, indirect, special, incidental, or consequential damages of any character arising as a result of this License or out of the use or inability to use the Work (including but not limited to damages for loss of goodwill, work stoppage, computer failure or malfunction, or any and all other commercial damages or losses), even if such Contributor has been advised of the possibility of such damages. 9. Accepting Warranty or Additional Liability. While redistributing the Work or Derivative Works thereof, You may choose to offer, and charge a fee for, acceptance of support, warranty, indemnity, or other liability obligations and/or rights consistent with this License. However, in accepting such obligations, You may act only on Your own behalf and on Your sole responsibility, not on behalf of any other Contributor, and only if You agree to indemnify, defend, and hold each Contributor harmless for any liability incurred by, or claims asserted against, such Contributor by reason of your accepting any such warranty or additional liability. END OF TERMS AND CONDITIONS APPENDIX: How to apply the Apache License to your work. To apply the Apache License to your work, attach the following boilerplate notice, with the fields enclosed by brackets &quot;[]&quot; replaced with your own identifying information. (Don't include the brackets!) The text should be enclosed in the appropriate comment syntax for the file format. We also recommend that a file or class name and description of purpose be included on the same &quot;printed page&quot; as the copyright notice for easier identification within third-party archives. Copyright 2022 John Wilger Licensed under the Apache License, Version 2.0 (the &quot;License&quot;); you may not use this file except in compliance with the License. You may obtain a copy of the License at http://www.apache.org/licenses/LICENSE-2.0 Unless required by applicable law or agreed to in writing, software distributed under the License is distributed on an &quot;AS IS&quot; BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. See the License for the specific language governing permissions and limitations under the License.","ref":"license.html","title":"LICENSE","type":"extras"}]